set(0,'DefaultFigureWindowStyle','docked')
%% Landmarks
% known correspondence

% Plot map
figure(1)
hold on; box on; axis equal

xlim([-0.2*scale-100,1.1*scale+100])
ylim([-0.1*scale-50,1.1*scale])
for i=1:N
    rectangle('Position',[map(i,1), map(i,2),5,5])
end

%% Parameters
dt=0.5;             % timestep [s]
Nt=200;             % number of steps
T=dt*Nt;
t=dt:dt:T;          % time coordinates
v=7.5;              % speed [m/s]

%% Models
% Motion model

g=@(v,w,fi) [-v/w*sin(fi)+v/w*sin(fi+w*dt);
             v/w*cos(fi)-v/w*cos(fi+w*dt);
             w*dt];

G=@(v,w,fi)[1 0 -v/w*sin(fi)+v/w*sin(fi+w*dt);
            0 1 v/w*cos(fi)-v/w*cos(fi+w*dt);
            0 0 1];

F=@(v,w,fi) [G(v,w,fi) zeros(3,2*N);
            zeros(2*N,3) eye(2*N)];
        

        
% Measurement model 
H1=@(delta,q) [-sqrt(q)*delta(1) -sqrt(q)*delta(2) 0;
                    delta(2) -delta(1) -q];

H2=@(delta,q) [sqrt(q)*delta(1) sqrt(q)*delta(2);
                    -delta(2) delta(1)];
H=@(delta,q,j) 1/q*[H1(delta,q),zeros(2,2*j-2),H2(delta,q),zeros(2,2*N-2*j)];


        
%% Path of the robot - a spiral



%% Init filter

FH = [];
for k = 2:Nt
   


 
       

      
      if ~isempty(FH)
        delete(FH(:))
      end
      XX=reshape(X(4:end)',2,N)';
      for i=1:N
            fh = rectangle('Position',[XX(i,1), XX(i,2),5,5],'Curvature',1,'FaceColor','red');
            FH(i) = fh;
      end
      drawnow      
end
XX-map

s=diag(diag(P));
cor = s^(-1/2)*P*s^(-1/2);
figure
subplot(1,2,1)
imagesc(cor)
subplot(1,2,2)
imagesc(inv(cor))

